#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <fcntl.h>
#include <sys/mman.h>
#include <linux/fb.h>
#include <unistd.h>
#include <stropts.h>
#include "SDL.h"

#define SCREEN_WIDTH 320
#define SCREEN_HEIGHT 240
#define SCREEN_DEPTH 8

extern int errno;
unsigned long *memregs32;
unsigned short *memregs16;

int memfd;

#define GPIOHOUT 0x106E

void *trymmap (void *start, size_t length, int prot, int flags, int fd, off_t offset)
{
	char *p;
	int aa;

	printf ("mmap(%X, %X, %X, %X, %X, %X) ... ", (unsigned int)start, length, prot, flags, fd, (unsigned int)offset);
    p = (char *) mmap (start, length, prot, flags, fd, offset); 
	if (p == (char *)0xFFFFFFFF)
	{
		aa = errno;
		printf ("failed. errno = %d\n", aa);
	}
	else
	{
		printf ("OK! (%X)\n", (unsigned int)p);
	}

	return p;
}

unsigned char initphys (void)
{
	memfd = open("/dev/mem", O_RDWR);
	if (memfd == -1)
	{
		printf ("Open failed\n");
		return 0;
	}

	printf ("/dev/mem opened successfully - fd = %d\n", memfd);

    memregs32 = (long unsigned int*) trymmap(0, 0x10000, PROT_READ|PROT_WRITE, MAP_SHARED, memfd, 0xc0000000); 
	if (memregs32 == (unsigned long *)0xFFFFFFFF) return 0;

	memregs16 = (unsigned short *)memregs32;

	return 1;
}

void closephys (void)
{
	close (memfd);
}

int main(void)
{
    SDL_Surface *screen;
    Uint8      *p;
    int w;
    double i,c;
    int         x; //x coordinate of our pixel
    int         y; //y coordinate of our pixel
    	
	if (!initphys()) return 0;
    
    /* Initialize SDL */
    SDL_Init(SDL_INIT_VIDEO);
     
    /* Initialize the screen / window */
    screen = SDL_SetVideoMode(SCREEN_WIDTH, SCREEN_HEIGHT, SCREEN_DEPTH, SDL_SWSURFACE);
    SDL_ShowCursor (0);

    SDL_FillRect(screen, NULL, 0xFF);

for (c = 0; c < 100; c+=0.05)
{
        i = 250+(cos(c)*250);
    	for (w = 0; w < (500-i)*5; w++) {}
		memregs16[GPIOHOUT >> 1] |= 4;           // Allumer OR 100
    	for (w = 0; w < i*5; w++) {}
		memregs16[GPIOHOUT >> 1] &= ~4;          // Eteindre AND 011

    x = (320/100)*c;
    y = (i/10)+95;

	    p = (Uint8 *)screen->pixels + y * screen->pitch + x * screen->format->BytesPerPixel;
	    *p=0x00;

    SDL_Flip(screen);
}

    memregs16[GPIOHOUT >> 1] |= 4;           // Allumer OR 100
	closephys();
	chdir("/usr/gp2x");
	execl("/usr/gp2x/gp2xmenu", "/usr/gp2x/gp2xmenu", NULL);
	return 0;
}
